package tp0;

/**
 * La classe pour l'index : un mot et sa liste
 * de page
 * @author jroyer
 *  9/12/2010
 */
public class Entry  {

	/** le mot de l'entree. */
	private String mot;

	/** la liste des pages du mot. */
	private SortedListOfInteger pages;

	/**
	 * Creation d'une nouvelle entree
	 * @param w
	 * @param ps
	 */
	public Entry(String w, SortedListOfInteger ps) {
		this.mot = w;
		this.pages = ps;
	}

	/**
	 * Ajoute une page dans la liste de l'entree.
	 * @param page
	 */
	public void add(Integer page) {
		this.getPages().add(page);
	}

	/**
	 * Representation en string.
	 */
	public String toString() {
		return this.getMot() + " " + this.getPages().toString();
	}

	/**
	 * Fonction de comparaisons.
	 * Compare les deux mots des entrees
	 * 0: egalite, -: inferieur, +: superieur
	 * @param other
	 * @return un entier
	 */
	public int compareTo(Entry other) {
		return this.getMot().compareTo(other.getMot());
	}

	/**
	 * @return le mot
	 */
	public String getMot() {
		return mot;
	}

	/**
	 * @param mot le mot a changer
	 */
	public void setMot(String mot) {
		this.mot = mot;
	}

	/**
	 * @return les pages
	 */
	public SortedListOfInteger getPages() {
		return pages;
	}

	/**
	 * @param pages les pages a changer
	 */
	public void setPages(SortedListOfInteger pages) {
		this.pages = pages;
	}

}
