package tp0;

/**
 * Classe simple qui lit un fichier en entre ligne par ligne
 *  et reecrit son contenu un mot par ligne.
 * Les lignes commenant par % sont ignorees.
 * @author jroyer
 *  9/12/2010
 */
public class MakeIndex extends Loader {

	/**
	 * Index du document.
	 */
	private Index index;

	/**
	 * Constructeur par defaut.
	 * @param name
	 */
	public MakeIndex(String name) {
		super(name);
		this.index = new Index();
	}

	/**
	 * Analyse les mots et cree l'index.
	 */
	public void process() {
		for (int i = 0; i < this.getMots().size(); i += 2) {
			String mot = this.getMots().get(i);
			Integer page = Integer.parseInt(this.getMots().get(i + 1));
			// le mot existe deja ou est nouveau
			if (this.getIndex().isIn(mot)) {
				// ajoute une page a l'entree existante
				Entry e = this.getIndex().get(mot);
				e.add(page);
			} else {
				// ajoute une nouvelle entree
				SortedListOfInteger ps = new SortedListOfInteger();
				ps.add(page);
				this.getIndex().add(new Entry(mot, ps));
			}
		}
	}

	/**
	 * @return the index
	 */
	public Index getIndex() {
		return index;
	}

	/**
	 * @param index the index to set
	 */
	public void setIndex(Index index) {
		this.index = index;
	}

}
