package tp0;

import java.util.Vector;

/**
 * Classe pour les listes d'entiers positifs et trie en ordre strictement
 * croissant.
 * 9/12/2010
 * @author jroyer
 */
public class SortedListOfInteger extends Vector<Integer> {

	/**
	 * default serial id.
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Liste de page vide.
	 */
	public SortedListOfInteger() {
		super();
	}

	// Ici vous pouvez ecrire
	// public void addPage(Integer page) {
	// plus simple

	// d'autre algorithmes sont possibles, par exemple
	// partir du debut, trouver la place puis faire un insert

	/**
	 * Ajout d'un nouvel entier. Doit respecter les contraintes : entier > 0 la
	 * liste est triee en ordre strictement croissant et doit le rester
	 *
	 * @param page
	 *            la page a ajouter
	 * @return true obligatoirement
	 */
	// solution laborieuse
	/*
	 * public boolean add(Integer page) { if (page <= 0) {
	 * System.err.println("SortedListOfInteger: a va pas la page ! " + page); }
	 * else { if (this.isEmpty()) { super.add(page); } else if
	 * (!this.contains(page)) { // ajout a la fin mais uniquement si pas deja
	 * dedans // Attention ici si vous utilisez une egalite // il vous faut
	 * .equals ! car ce sont des integer super.add(page); // dernier indice du
	 * vecteur int i = this.size() - 1; // echange les elements si pas dans le
	 * bon ordre while (i > 0) { int pred = this.get(i - 1); int last =
	 * this.get(i); if (last < pred) { this.set(i - 1, last); this.set(i, pred);
	 * i--; } else { // pour arreter de force i = 0; } } } } return true; }
	 */

	// la solution la plus simple (may be)
	// ATTention le boolean est impose par l'heritage de Vector
	public boolean add(Integer page) {
		if (!this.contains(page)) {
			if (this.isEmpty()) {
				super.add(page);
			} else {
				int i = 0;
				while ((i < this.size()) && (page > this.get(i))) {
					i++;
				}
				super.add(i, page);
			}
		}
		return true;
	}

	/**
	 * Format de sortie avec des "," comme sparateur.
	 */
	public String toString() {
		String result = "";
		// gerer le cas particulier 1 element
		if (this.size() > 0) {
			result += this.get(0);
			for (int i = 1; i < this.size(); i++) {
				result += ", " + this.get(i);
			}
		}
		return result;
	}
}
